Deleted Added
full compact
index.subr (252987) index.subr (257795)
1if [ ! "$_PACKAGES_INDEX_SUBR" ]; then _PACKAGES_INDEX_SUBR=1
2#
3# Copyright (c) 2013 Devin Teske
4# All rights reserved.
5#
6# Redistribution and use in source and binary forms, with or without
7# modification, are permitted provided that the following conditions
8# are met:
9# 1. Redistributions of source code must retain the above copyright
10# notice, this list of conditions and the following disclaimer.
11# 2. Redistributions in binary form must reproduce the above copyright
12# notice, this list of conditions and the following disclaimer in the
13# documentation and/or other materials provided with the distribution.
14#
15# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
16# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
17# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
18# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
19# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
20# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
21# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
22# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
23# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
24# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
25# SUCH DAMAGE.
26#
1if [ ! "$_PACKAGES_INDEX_SUBR" ]; then _PACKAGES_INDEX_SUBR=1
2#
3# Copyright (c) 2013 Devin Teske
4# All rights reserved.
5#
6# Redistribution and use in source and binary forms, with or without
7# modification, are permitted provided that the following conditions
8# are met:
9# 1. Redistributions of source code must retain the above copyright
10# notice, this list of conditions and the following disclaimer.
11# 2. Redistributions in binary form must reproduce the above copyright
12# notice, this list of conditions and the following disclaimer in the
13# documentation and/or other materials provided with the distribution.
14#
15# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
16# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
17# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
18# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
19# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
20# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
21# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
22# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
23# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
24# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
25# SUCH DAMAGE.
26#
27# $FreeBSD: head/usr.sbin/bsdconfig/share/packages/index.subr 252987 2013-07-07 18:51:44Z dteske $
27# $FreeBSD: head/usr.sbin/bsdconfig/share/packages/index.subr 257795 2013-11-07 12:40:42Z dteske $
28#
29############################################################ INCLUDES
30
31BSDCFG_SHARE="/usr/share/bsdconfig"
32. $BSDCFG_SHARE/common.subr || exit 1
33f_dprintf "%s: loading includes..." packages/index.subr
34f_include $BSDCFG_SHARE/device.subr
35f_include $BSDCFG_SHARE/media/common.subr
36f_include $BSDCFG_SHARE/strings.subr
37
38BSDCFG_LIBE="/usr/libexec/bsdconfig"
39f_include_lang $BSDCFG_LIBE/include/messages.subr
40
41############################################################ GLOBALS
42
43PACKAGE_INDEX=
44_INDEX_INITTED=
45
28#
29############################################################ INCLUDES
30
31BSDCFG_SHARE="/usr/share/bsdconfig"
32. $BSDCFG_SHARE/common.subr || exit 1
33f_dprintf "%s: loading includes..." packages/index.subr
34f_include $BSDCFG_SHARE/device.subr
35f_include $BSDCFG_SHARE/media/common.subr
36f_include $BSDCFG_SHARE/strings.subr
37
38BSDCFG_LIBE="/usr/libexec/bsdconfig"
39f_include_lang $BSDCFG_LIBE/include/messages.subr
40
41############################################################ GLOBALS
42
43PACKAGE_INDEX=
44_INDEX_INITTED=
45
46#
47# Default path to pkg(8) repo-packagesite.sqlite database
48#
49SQLITE_REPO="/var/db/pkg/repo-packagesite.sqlite"
50
51#
52# Default path to on-disk cache INDEX file
53#
54PACKAGES_INDEX_CACHEFILE="/var/run/bsdconfig/packages_INDEX.cache"
55
56#
57# INDEX format for FreeBSD-6.0 or higher:
58#
59# package|port-origin|install-prefix|comment|port-desc-file|maintainer|
60# categories|build-deps|run-deps|www-site|reserve|reserve|reserve|disc
61#
62INDEX_FORMAT="%n-%v" # package
63INDEX_FORMAT="$INDEX_FORMAT|/usr/ports/%o" # port-origin
64INDEX_FORMAT="$INDEX_FORMAT|%p" # install-prefix
65INDEX_FORMAT="$INDEX_FORMAT|%c" # comment
66INDEX_FORMAT="$INDEX_FORMAT|/usr/ports/%o/pkg-descr" # port-desc-file
67INDEX_FORMAT="$INDEX_FORMAT|%m" # maintainer
68INDEX_FORMAT="$INDEX_FORMAT|@CATEGORIES@" # place-holder
69INDEX_FORMAT="$INDEX_FORMAT|" # build-deps
70INDEX_FORMAT="$INDEX_FORMAT|@RUNDEPS@" # place-holder
71INDEX_FORMAT="$INDEX_FORMAT|%w" # www-site
72INDEX_FORMAT="$INDEX_FORMAT|" # reserved
73INDEX_FORMAT="$INDEX_FORMAT|" # reserved
74INDEX_FORMAT="$INDEX_FORMAT|" # reserved
75INDEX_FORMAT="$INDEX_FORMAT|" # disc
76
46############################################################ FUNCTIONS
47
77############################################################ FUNCTIONS
78
48# f_index_initialize $path [$var_to_set]
79# f_index_initialize [$var_to_set]
49#
80#
50# Read and initialize the global index. $path is to be relative to the chosen
51# media (not necessarily the filesystem; e.g. FTP) -- this is usually going to
52# be `packages/INDEX'. Returns success unless media cannot be initialized for
53# any reason (e.g. user cancels media selection dialog) or an error occurs. The
54# index is sorted before being loaded into $var_to_set.
81# Read and initialize the global index. Returns success unless media cannot be
82# initialized for any reason (e.g. user cancels media selection dialog or an
83# error occurs). The index is sorted before being loaded into $var_to_set.
55#
56# NOTE: The index is processed with f_index_read() [below] after being loaded.
57#
58f_index_initialize()
59{
84#
85# NOTE: The index is processed with f_index_read() [below] after being loaded.
86#
87f_index_initialize()
88{
60 local __path="$1" __var_to_set="${2:-PACKAGE_INDEX}"
89 local __var_to_set="${2:-PACKAGE_INDEX}"
61
62 [ "$_INDEX_INITTED" ] && return $SUCCESS
90
91 [ "$_INDEX_INITTED" ] && return $SUCCESS
63 [ "$__path" ] || return $FAILURE
64
65 # Got any media?
66 f_media_verify || return $FAILURE
67
68 # Does it move when you kick it?
69 f_device_init media || return $FAILURE
70
92
93 # Got any media?
94 f_media_verify || return $FAILURE
95
96 # Does it move when you kick it?
97 f_device_init media || return $FAILURE
98
71 f_show_info "$msg_attempting_to_fetch_file_from_selected_media" \
72 "$__path"
73 eval "$__var_to_set"='$( f_device_get media "$__path" )'
74 if [ $? -ne $SUCCESS ]; then
75 f_show_msg "$msg_unable_to_get_file_from_selected_media" \
76 "$__path"
99 f_show_info "$msg_attempting_to_update_repository_catalogue"
100
101 #
102 # Generate $PACKAGESITE variable for pkg(8) based on media type
103 #
104 local __type __data __site
105 device_media get type __type
106 device_media get private __data
107 case "$__type" in
108 $DEVICE_TYPE_UFS|$DEVICE_TYPE_DISK) __site="file://$MOUNTPOINT" ;;
109 $DEVICE_TYPE_DIRECTORY) __site="file://$__data" ;;
110 $DEVICE_TYPE_FLOPPY) __site="file://${__data:-$MOUNTPOINT}" ;;
111 $DEVICE_TYPE_FTP) f_getvar $VAR_FTP_PATH __site ;;
112 $DEVICE_TYPE_HTTP_PROXY) f_getvar $VAR_HTTP_PROXY_PATH __site ;;
113 $DEVICE_TYPE_HTTP) f_getvar $VAR_HTTP_PATH __site ;;
114 $DEVICE_TYPE_CDROM) __site="file://$MOUNTPOINT" ;;
115 $DEVICE_TYPE_USB) __site="file://$MOUNTPOINT" ;;
116 $DEVICE_TYPE_DOS) __site="file://$MOUNTPOINT" ;;
117 $DEVICE_TYPE_NFS) __site="file://$MOUNTPOINT" ;;
118 esac
119
120 if ! PACKAGESITE="$__site" f_quietly pkg update; then
121 f_show_err "$msg_unable_to_update_pkg_from_selected_media"
77 f_device_shutdown media
78 return $FAILURE
79 fi
122 f_device_shutdown media
123 return $FAILURE
124 fi
125
126 #
127 # Try to get contents from validated on-disk cache
128 #
129
130 #
131 # Calculate digest used to determine if the on-disk persistant cache
132 # INDEX (containing this digest on the first line) is valid and can be
133 # used to quickly populate the environment.
134 #
135 local __sqlite_digest
136 if ! __sqlite_digest=$( md5 < "$SQLITE_REPO" 2> /dev/null ); then
137 f_show_err "$msg_no_pkg_database_found"
138 f_device_shutdown media
139 return $FAILURE
140 fi
141
142 #
143 # Check to see if the persistant cache INDEX file exists
144 #
145 if [ -f "$PACKAGES_INDEX_CACHEFILE" ]; then
146 #
147 # Attempt to populate the environment with the (soon to be)
148 # validated on-disk cache. If validation fails, fall-back to
149 # generating a fresh cache.
150 #
151 if eval $__var_to_set='$(
152 ( # Get digest as the first word on first line
153 read digest rest_ignored
154
155 #
156 # If the stored digest matches the calculated-
157 # one populate the environment from the on-disk
158 # cache and provide success exit status.
159 #
160 if [ "$digest" = "$__sqlite_digest" ]; then
161 cat
162 exit $SUCCESS
163 else
164 # Otherwise, return the current value
165 eval echo \"\$__var_to_set\"
166 exit $FAILURE
167 fi
168 ) < "$PACKAGES_INDEX_CACHEFILE" 2> /dev/null
169 )'; then
170 f_show_info \
171 "$msg_located_index_now_reading_package_data_from_it"
172 if ! f_index_read "$__var_to_set"; then
173 f_show_err \
174 "$msg_io_or_format_error_on_index_file"
175 return $FAILURE
176 fi
177 _INDEX_INITTED=1
178 return $SUCCESS
179 fi
180 # Otherwise, fall-thru to create a fresh cache from scratch
181 fi
182
183 #
184 # If we reach this point, we need to generate the data from scratch
185 #
186
187 f_show_info "$msg_getting_package_categories_via_pkg_rquery"
188 if ! eval "$( pkg rquery "%n-%v %C" | awk '
189 { categories[$1] = categories[$1] " " $2 }
190 END {
191 for (package in categories)
192 {
193 cats = categories[package]
194 sub(/^ /, "", cats)
195 gsub(/[^[:alnum:]_]/, "_", package)
196 printf "local _%s_categories=\"%s\";\n", package, cats
197 }
198 }' )"; then
199 f_show_err "$msg_unable_to_pkg_rquery_package_dependeices"
200 f_device_shutdown media
201 return $FAILURE
202 fi
203
204 f_show_info "$msg_getting_package_dependencies_via_pkg_rquery"
205 if ! eval "$( pkg rquery "%n-%v %dn-%dv" | awk '
206 { rundeps[$1] = rundeps[$1] " " $2 }
207 END {
208 for (package in rundeps)
209 {
210 deps = rundeps[package]
211 sub(/^ /, "", deps)
212 gsub(/[^[:alnum:]_]/, "_", package)
213 printf "local _%s_rundeps=\"%s\";\n", package, deps
214 }
215 }' )"; then
216 f_show_err "$msg_unable_to_pkg_rquery_package_dependeices"
217 f_device_shutdown media
218 return $FAILURE
219 fi
220
221 f_show_info "$msg_generating_index_from_pkg_database"
222 eval "$__var_to_set"='$( pkg rquery "$INDEX_FORMAT" |
223 while read LINE; do
224 package="${LINE%%|*}";
225 f_str2varname "$package" varpkg;
226 eval f_replaceall \"\$LINE\" \"\|@CATEGORIES@\|\" \
227 \"\|\$_${varpkg}_categories\|\" LINE
228 eval f_replaceall \"\$LINE\" \"\|@RUNDEPS@\|\" \
229 \"\|\$_${varpkg}_rundeps\|\" LINE
230 echo "$LINE"
231 done
232 )' # always returns true (status of last item in pipe-chain)
80 eval "$__var_to_set"='$( debug= f_getvar "$__var_to_set" | sort )'
81
233 eval "$__var_to_set"='$( debug= f_getvar "$__var_to_set" | sort )'
234
235 #
236 # Attempt to create the persistant on-disk cache
237 #
238
239 # Create a new temporary file to write to
240 local __tmpfile="$( mktemp -t "$pgm" )"
241 if [ "$__tmpfile" ]; then
242 # Write the temporary file contents
243 echo "$__sqlite_digest" > "$__tmpfile"
244 debug= f_getvar "$__var_to_set" >> "$__tmpfile"
245
246 # Finally, move the temporary file into place
247 case "$PACKAGES_INDEX_CACHEFILE" in
248 */*) f_quietly mkdir -p "${PACKAGES_INDEX_CACHEFILE%/*}"
249 esac
250 f_quietly mv -f "$__tmpfile" "$PACKAGES_INDEX_CACHEFILE"
251 fi
252
82 f_show_info "$msg_located_index_now_reading_package_data_from_it"
83 if ! f_index_read "$__var_to_set"; then
253 f_show_info "$msg_located_index_now_reading_package_data_from_it"
254 if ! f_index_read "$__var_to_set"; then
84 f_show_msg "$msg_io_or_format_error_on_index_file" "$__path"
255 f_show_err "$msg_io_or_format_error_on_index_file"
85 return $FAILURE
86 fi
87
88 _INDEX_INITTED=1
89 return $SUCCESS
90}
91
92# f_index_read [$var_to_get]
93#
94# Process the INDEX file (contents contained in $var_to_get) and...
95#
96# 1. create a list ($CATEGORY_MENU_LIST) of categories with package counts
97# 2. For convenience, create $_npkgs holding the total number of all packages
98# 3. extract associative categories for each package into $_categories_$varpkg
99# 4. extract runtime dependencies for each package into $_rundeps_$varpkg
100# 5. extract a [sorted] list of categories into $PACKAGE_CATEGORIES
101# 6. create $_npkgs_$varcat holding the total number of packages in category
102#
103# NOTE: $varpkg is the product of f_str2varname $package varpkg
104# NOTE: $package is the name as it appears in the INDEX (no archive suffix)
105# NOTE: We only show categories for which there are at least one package.
106# NOTE: $varcat is the product of f_str2varname $category varcat
107#
108f_index_read()
109{
110 local var_to_get="${1:-PACKAGE_INDEX}"
111
112 # Export variables required by awk(1) below
113 export msg_no_description_provided
114 export msg_all msg_all_desc
115 export VALID_VARNAME_CHARS
116 export msg_packages
117
118 eval "$( debug= f_getvar "$var_to_get" | awk -F'|' '
119 function asorti(src, dest)
120 {
121 # Copy src indices to dest and calculate array length
122 nitems = 0; for (i in src) dest[++nitems] = i
123
124 # Sort the array of indices (dest) using insertion sort method
125 for (i = 1; i <= nitems; k = i++)
126 {
127 idx = dest[i]
128 while ((k > 0) && (dest[k] > idx))
129 {
130 dest[k+1] = dest[k]
131 k--
132 }
133 dest[k+1] = idx
134 }
135
136 return nitems
137 }
138 function print_category(category, npkgs, desc)
139 {
140 cat = category
141 # Accent the category if the first page has been
142 # cached (also acting as a visitation indicator)
143 if ( ENVIRON["_index_page_" varcat "_1"] )
144 cat = cat "*"
145 printf "'\''%s'\'' '\''%s " packages "'\'' '\''%s'\''\n",
146 cat, npkgs, desc
147 }
148 BEGIN {
149 valid_chars = ENVIRON["VALID_VARNAME_CHARS"]
150 default_desc = ENVIRON["msg_no_description_provided"]
151 packages = ENVIRON["msg_packages"]
152 tpkgs = 0
153 prefix = ""
154 }
155 {
156 tpkgs++
157 varpkg = $1
158 gsub("[^" valid_chars "]", "_", varpkg)
159 print "_categories_" varpkg "=\"" $7 "\""
160 split($7, pkg_categories, /[[:space:]]+/)
161 for (pkg_category in pkg_categories)
162 categories[pkg_categories[pkg_category]]++
163 print "_rundeps_" varpkg "=\"" $9 "\""
164 }
165 END {
166 print "_npkgs=" tpkgs # For convenience, total package count
167
168 n = asorti(categories, categories_sorted)
169
170 # Produce package counts for each category
171 for (i = 1; i <= n; i++)
172 {
173 cat = varcat = categories_sorted[i]
174 npkgs = categories[cat]
175 gsub("[^" valid_chars "]", "_", varcat)
176 print "_npkgs_" varcat "=\"" npkgs "\""
177 }
178
179 # Create menu list and generate list of categories at same time
180 print "CATEGORY_MENU_LIST=\""
181 print_category(ENVIRON["msg_all"], tpkgs,
182 ENVIRON["msg_all_desc"])
183 category_list = ""
184 for (i = 1; i <= n; i++)
185 {
186 cat = varcat = categories_sorted[i]
187 npkgs = categories[cat]
188 cur_prefix = tolower(substr(cat, 1, 1))
189 if ( prefix != cur_prefix )
190 prefix = cur_prefix
191 else
192 cat = " " cat
193 gsub("[^" valid_chars "]", "_", varcat)
194 desc = ENVIRON["_category_" varcat]
195 if ( ! desc ) desc = default_desc
196 print_category(cat, npkgs, desc)
197 category_list = category_list " " cat
198 }
199 print "\""
200
201 # Produce the list of categories (calculated in above block)
202 sub(/^ /, "", category_list)
203 print "PACKAGE_CATEGORIES=\"" category_list "\""
204
205 }' )" # End-Quote
206}
207
208# f_index_extract_pages $var_to_get $var_basename $pagesize [$category]
209#
210# Extracts the package INDEX ($PACKAGE_INDEX by default if/when $var_to_get is
211# NULL; but should not be missing) into a series of sequential variables
212# corresponding to "pages" containing up to $pagesize packages. The package
213# INDEX data must be contained in the variable $var_to_get. The extracted pages
214# are stored in variables ${var_basename}_# -- where "#" is a the page number.
215# If $category is set, only packages for that category are extracted.
216# Otherwise, if $category is "All", missing, or NULL, all packages are
217# extracted and no filtering is done.
218#
219f_index_extract_pages()
220{
221 local var_to_get="${1:-PACKAGE_INDEX}" var_basename="$2" pagesize="$3"
222 local category="$4" # Optional
223
224 eval "$(
225 debug= f_getvar "$var_to_get" | awk -F'|' \
226 -v cat="$category" \
227 -v pagesize="$pagesize" \
228 -v var_basename="$var_basename" \
229 -v i18n_all="$msg_all" '
230 BEGIN { n = page = 0 }
231 /'\''/{ gsub(/'\''/, "'\''\\'\'\''") }
232 {
233 if ( cat !~ "(^$|^" i18n_all "$)" && $7 !~ \
234 "(^|[[:space:]])" cat "([[:space:]]|$)" ) next
235 starting_new_page = (n++ == (pagesize * page))
236 if ( starting_new_page )
237 printf "%s%s", ( n > 1 ? "'\''\n" : "" ),
238 var_basename "_" ++page "='\''"
239 printf "%s%s", ( starting_new_page ? "" : "\n" ), $0
240 }
241 END { if ( n > 0 ) print "'\''" }'
242 )"
243}
244
245# f_index_search $var_to_get $name [$var_to_set]
246#
247# Search the package INDEX ($PACKAGE_INDEX by default if/when $var_to_get is
248# NULL; but should not be missing) for $name, returning the first match.
249# Matches are strict (not regular expressions) and must match the beginning
250# portion of the package name to be considered a match. If $var_to_set is
251# missing or NULL, output is sent to standard output. If a match is found,
252# returns success; otherwise failure.
253#
254f_index_search()
255{
256 local __var_to_get="${1:-PACKAGE_INDEX}" __pkg_basename="$2"
257 local __var_to_set="$3"
258
259 f_dprintf "f_index_search: Searching package data (in %s) for %s" \
260 "$__var_to_get" "$__pkg_basename"
261
262 local __pkg=
263 __pkg=$( debug= f_getvar "$__var_to_get" |
264 awk -F'|' -v basename="$__pkg_basename" '
265 BEGIN { n = length(basename) }
266 substr($1, 0, n) == basename { print $1; exit }
267 ' )
268 if [ ! "$__pkg" ]; then
269 f_dprintf "f_index_search: No packages matching %s found" \
270 "$__pkg_basename"
271 return $FAILURE
272 fi
273
274 f_dprintf "f_index_search: Found package %s" "$__pkg"
275 if [ "$__var_to_set" ]; then
276 setvar "$__var_to_set" "$__pkg"
277 else
278 echo "$__pkg"
279 fi
280 return $SUCCESS
281}
282
283############################################################ MAIN
284
285f_dprintf "%s: Successfully loaded." packages/index.subr
286
287fi # ! $_PACKAGES_INDEX_SUBR
256 return $FAILURE
257 fi
258
259 _INDEX_INITTED=1
260 return $SUCCESS
261}
262
263# f_index_read [$var_to_get]
264#
265# Process the INDEX file (contents contained in $var_to_get) and...
266#
267# 1. create a list ($CATEGORY_MENU_LIST) of categories with package counts
268# 2. For convenience, create $_npkgs holding the total number of all packages
269# 3. extract associative categories for each package into $_categories_$varpkg
270# 4. extract runtime dependencies for each package into $_rundeps_$varpkg
271# 5. extract a [sorted] list of categories into $PACKAGE_CATEGORIES
272# 6. create $_npkgs_$varcat holding the total number of packages in category
273#
274# NOTE: $varpkg is the product of f_str2varname $package varpkg
275# NOTE: $package is the name as it appears in the INDEX (no archive suffix)
276# NOTE: We only show categories for which there are at least one package.
277# NOTE: $varcat is the product of f_str2varname $category varcat
278#
279f_index_read()
280{
281 local var_to_get="${1:-PACKAGE_INDEX}"
282
283 # Export variables required by awk(1) below
284 export msg_no_description_provided
285 export msg_all msg_all_desc
286 export VALID_VARNAME_CHARS
287 export msg_packages
288
289 eval "$( debug= f_getvar "$var_to_get" | awk -F'|' '
290 function asorti(src, dest)
291 {
292 # Copy src indices to dest and calculate array length
293 nitems = 0; for (i in src) dest[++nitems] = i
294
295 # Sort the array of indices (dest) using insertion sort method
296 for (i = 1; i <= nitems; k = i++)
297 {
298 idx = dest[i]
299 while ((k > 0) && (dest[k] > idx))
300 {
301 dest[k+1] = dest[k]
302 k--
303 }
304 dest[k+1] = idx
305 }
306
307 return nitems
308 }
309 function print_category(category, npkgs, desc)
310 {
311 cat = category
312 # Accent the category if the first page has been
313 # cached (also acting as a visitation indicator)
314 if ( ENVIRON["_index_page_" varcat "_1"] )
315 cat = cat "*"
316 printf "'\''%s'\'' '\''%s " packages "'\'' '\''%s'\''\n",
317 cat, npkgs, desc
318 }
319 BEGIN {
320 valid_chars = ENVIRON["VALID_VARNAME_CHARS"]
321 default_desc = ENVIRON["msg_no_description_provided"]
322 packages = ENVIRON["msg_packages"]
323 tpkgs = 0
324 prefix = ""
325 }
326 {
327 tpkgs++
328 varpkg = $1
329 gsub("[^" valid_chars "]", "_", varpkg)
330 print "_categories_" varpkg "=\"" $7 "\""
331 split($7, pkg_categories, /[[:space:]]+/)
332 for (pkg_category in pkg_categories)
333 categories[pkg_categories[pkg_category]]++
334 print "_rundeps_" varpkg "=\"" $9 "\""
335 }
336 END {
337 print "_npkgs=" tpkgs # For convenience, total package count
338
339 n = asorti(categories, categories_sorted)
340
341 # Produce package counts for each category
342 for (i = 1; i <= n; i++)
343 {
344 cat = varcat = categories_sorted[i]
345 npkgs = categories[cat]
346 gsub("[^" valid_chars "]", "_", varcat)
347 print "_npkgs_" varcat "=\"" npkgs "\""
348 }
349
350 # Create menu list and generate list of categories at same time
351 print "CATEGORY_MENU_LIST=\""
352 print_category(ENVIRON["msg_all"], tpkgs,
353 ENVIRON["msg_all_desc"])
354 category_list = ""
355 for (i = 1; i <= n; i++)
356 {
357 cat = varcat = categories_sorted[i]
358 npkgs = categories[cat]
359 cur_prefix = tolower(substr(cat, 1, 1))
360 if ( prefix != cur_prefix )
361 prefix = cur_prefix
362 else
363 cat = " " cat
364 gsub("[^" valid_chars "]", "_", varcat)
365 desc = ENVIRON["_category_" varcat]
366 if ( ! desc ) desc = default_desc
367 print_category(cat, npkgs, desc)
368 category_list = category_list " " cat
369 }
370 print "\""
371
372 # Produce the list of categories (calculated in above block)
373 sub(/^ /, "", category_list)
374 print "PACKAGE_CATEGORIES=\"" category_list "\""
375
376 }' )" # End-Quote
377}
378
379# f_index_extract_pages $var_to_get $var_basename $pagesize [$category]
380#
381# Extracts the package INDEX ($PACKAGE_INDEX by default if/when $var_to_get is
382# NULL; but should not be missing) into a series of sequential variables
383# corresponding to "pages" containing up to $pagesize packages. The package
384# INDEX data must be contained in the variable $var_to_get. The extracted pages
385# are stored in variables ${var_basename}_# -- where "#" is a the page number.
386# If $category is set, only packages for that category are extracted.
387# Otherwise, if $category is "All", missing, or NULL, all packages are
388# extracted and no filtering is done.
389#
390f_index_extract_pages()
391{
392 local var_to_get="${1:-PACKAGE_INDEX}" var_basename="$2" pagesize="$3"
393 local category="$4" # Optional
394
395 eval "$(
396 debug= f_getvar "$var_to_get" | awk -F'|' \
397 -v cat="$category" \
398 -v pagesize="$pagesize" \
399 -v var_basename="$var_basename" \
400 -v i18n_all="$msg_all" '
401 BEGIN { n = page = 0 }
402 /'\''/{ gsub(/'\''/, "'\''\\'\'\''") }
403 {
404 if ( cat !~ "(^$|^" i18n_all "$)" && $7 !~ \
405 "(^|[[:space:]])" cat "([[:space:]]|$)" ) next
406 starting_new_page = (n++ == (pagesize * page))
407 if ( starting_new_page )
408 printf "%s%s", ( n > 1 ? "'\''\n" : "" ),
409 var_basename "_" ++page "='\''"
410 printf "%s%s", ( starting_new_page ? "" : "\n" ), $0
411 }
412 END { if ( n > 0 ) print "'\''" }'
413 )"
414}
415
416# f_index_search $var_to_get $name [$var_to_set]
417#
418# Search the package INDEX ($PACKAGE_INDEX by default if/when $var_to_get is
419# NULL; but should not be missing) for $name, returning the first match.
420# Matches are strict (not regular expressions) and must match the beginning
421# portion of the package name to be considered a match. If $var_to_set is
422# missing or NULL, output is sent to standard output. If a match is found,
423# returns success; otherwise failure.
424#
425f_index_search()
426{
427 local __var_to_get="${1:-PACKAGE_INDEX}" __pkg_basename="$2"
428 local __var_to_set="$3"
429
430 f_dprintf "f_index_search: Searching package data (in %s) for %s" \
431 "$__var_to_get" "$__pkg_basename"
432
433 local __pkg=
434 __pkg=$( debug= f_getvar "$__var_to_get" |
435 awk -F'|' -v basename="$__pkg_basename" '
436 BEGIN { n = length(basename) }
437 substr($1, 0, n) == basename { print $1; exit }
438 ' )
439 if [ ! "$__pkg" ]; then
440 f_dprintf "f_index_search: No packages matching %s found" \
441 "$__pkg_basename"
442 return $FAILURE
443 fi
444
445 f_dprintf "f_index_search: Found package %s" "$__pkg"
446 if [ "$__var_to_set" ]; then
447 setvar "$__var_to_set" "$__pkg"
448 else
449 echo "$__pkg"
450 fi
451 return $SUCCESS
452}
453
454############################################################ MAIN
455
456f_dprintf "%s: Successfully loaded." packages/index.subr
457
458fi # ! $_PACKAGES_INDEX_SUBR